version: '3.4'

x-cache-from:
  - &api-cache-from
    cache_from:
      - ${NGINX_IMAGE:?NGINX_IMAGE is not set or empty}
      - ${PHP_IMAGE:?PHP_IMAGE is not set or empty}
      - ${VARNISH_IMAGE:?VARNISH_IMAGE is not set or empty}
      - ${CLIENT_IMAGE:?CLIENT_IMAGE is not set or empty}

services:
  php:
    build:
      context: ../api
      target: api_php
      <<: *api-cache-from
    image: ${PHP_IMAGE:?PHP_IMAGE is not set or empty}

  api:
    build:
      context: ../api
      target: api_nginx
      <<: *api-cache-from
    image: ${NGINX_IMAGE:?NGINX_IMAGE is not set or empty}
    depends_on:
      - php

  cache-proxy:
    build:
      context: ../api
      target: api_varnish
      <<: *api-cache-from
    image: ${VARNISH_IMAGE:?VARNISH_IMAGE is not set or empty}
    depends_on:
      - api

  client:
    build:
      context: ../client
      target: client_nginx
      args:
        - REACT_APP_API_ENTRYPOINT=${REACT_APP_API_ENTRYPOINT:?REACT_APP_API_ENTRYPOINT is not set or empty}
      cache_from:
        - ${CLIENT_IMAGE:?CLIENT_IMAGE is not set or empty}
    image: ${CLIENT_IMAGE:?CLIENT_IMAGE is not set or empty}